using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Firm
{
    public partial class Form1 : Form
    {
        /// <summary>
        ///  
        /// </summary>
        string strConnect = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=FIRM.MDB";
        OleDbConnection connect = null;
		DataSet dataSetDepts = new DataSet();
        DataRelation _depDataRelation;
        /// <summary>
        /// Constructor
        /// </summary>
        public Form1()
        {
            InitializeComponent();
            try
            {
                connect = new OleDbConnection(strConnect);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error: Failed to create a database connection. \n{0}", ex.Message);
                Application.Exit();
            }
        }
        /// <summary>
        ///     []
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void itExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        /// <summary>
        ///     [ ]
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void About_Click(object sender, EventArgs e)
        {
            AboutBox1 dlg = new AboutBox1();
            dlg.ShowDialog(this);
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            if (!FillTreeVew(this.tvDepts))
                Application.Exit();
            tvDepts.ExpandAll();
        }
        // TreeView
        /// <summary>
        ///   
        /// </summary>
        /// <param name="tv -   TreeeView"></param>
        /// <returns>true   </returns>
        bool FillTreeVew(TreeView tv)
        {

            try
            {

                OleDbCommand comm = new OleDbCommand("SELECT * FROM tblDeps", connect);
                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                connect.Open();
                adapter.Fill(dataSetDepts, "tblDeps");

                _depDataRelation = new DataRelation("RootChild", dataSetDepts.Tables["tblDeps"].Columns["nDepId"], dataSetDepts.Tables["tblDeps"].Columns["nPrnDepId"]);
                dataSetDepts.Relations.Add(_depDataRelation);
            }
            catch (Exception ex)
            {
                string msg = "Error: Failed to retrieve the required data from the DataBase.\\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                return false;
            }
            finally
            {
                connect.Close();
            }
            if (dataSetDepts == null || !dataSetDepts.Tables.Contains("tblDeps"))
            {
                MessageBox.Show("Error: Failed to retrieve the data from the DataBase: dataSetDepts == null.");
                return false;
            }
            DataRow[] drRoot = dataSetDepts.Tables["tblDeps"].Select("(nPrnDepId IS NULL OR nPrnDepId = 0)");
            if (drRoot.Length == 0)
            {
                MessageBox.Show("Error: Failed to retrieve the root node from the DataBase.");
                return false;
            }
            AddChildNodes(tv,null, drRoot[0]);
            return true;
        }
        /// <summary>
        ///   TreeeView
        /// </summary>
        /// <param name="tv">  TreeeView</param>
        /// <param name="aNode"> </param>
        /// <param name="aRow">      </param>
        private void AddChildNodes(TreeView tv,TreeNode aNode, DataRow aRow)
        {
            TreeNode node = new TreeNode();
            node.Text = aRow["cCode"].ToString();
            node.Tag = Convert.ToInt32(aRow["nDepId"]);
            if (aNode == null)
                tv.Nodes.Add(node);
            else
                aNode.Nodes.Add(node);
            DataRow[] drParent = aRow.GetChildRows(_depDataRelation);
            foreach (DataRow row in drParent)
            {
                AddChildNodes(tv,node, row);
            }
        }
        /// <summary>
        ///    
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tvDepts_AfterSelect(object sender, TreeViewEventArgs e)
        {
            int idprnt = (int )e.Node.Tag;
            this.tbDel.Enabled = true;
            this.tbEdit.Enabled = true;
            this.lvEmps.Items.Clear();
            Fill_lvEmps(idprnt);
        }
        /// <summary>
        ///      
        /// </summary>
        /// <param name="nDepId"></param>
        void Fill_lvEmps(int nDepId)
        {
            dataSetDepts.Relations.Clear();
            dataSetDepts.Tables.Clear();
            String sql = "SELECT * FROM tblEmps WHERE (nDepId = " + nDepId.ToString() + ") ";
            sql += " ORDER BY cLastName,cFirstName,cPatronymic;";
            try
            {

                OleDbCommand comm = new OleDbCommand(sql, connect);
                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                connect.Open();
                adapter.Fill(dataSetDepts, "tblEmps");
                DataTable tblEmps = dataSetDepts.Tables["tblEmps"];
                DataRowCollection drEmps = dataSetDepts.Tables["tblEmps"].Rows;

                foreach (DataRow row in drEmps)
                {
                    try
                    {
                        ListViewItem lvi = new ListViewItem(Convert.ToString(row["cLastName"]));
                        lvi.SubItems.Add(Convert.ToString(row["cFirstName"]));
                        lvi.SubItems.Add(Convert.ToString(row["cPatronymic"]));
                        lvi.SubItems.Add(Convert.ToString(row["cPost"]));
                        lvi.SubItems.Add(Convert.ToString(row["dBirthDate"]));
                        lvi.Tag = Convert.ToInt32(row["nEmpId"]);
                        this.lvEmps.Items.Add(lvi);
                        if (lvEmps.Items.Count % 2 == 0)
                            lvi.BackColor = Color.AliceBlue;
                    }
                    catch (Exception ex)
                    {
                        string msg = "Error: (Fill_lvEmps)Failed to retrieve the required data from the DataBase.\n";
                        msg += ex.Message;
                        MessageBox.Show(msg);
                        break;
                    }
                }
            }
            catch (Exception ex)
            {
                string msg = "Error: (Fill_lvEmps)Failed to retrieve the required data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                //              return;
            }
            finally
            {
                connect.Close();
            }
        }
        /// <summary>
        ///    
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            switch ((string)e.ClickedItem.Tag)
            {
                case "New":
                    if (this.tvDepts.Focused)
                        AddEditDepts(false);
                    else
                        if (tvDepts.SelectedNode != null)
                            AddEditEmp(false);
                    break;
                case "Edit":
                    if (tvDepts.SelectedNode != null)
                    {
                        if (this.tvDepts.Focused)
                            AddEditDepts(true);
                        else
                        {
                            if (this.lvEmps.SelectedItems.Count == 0)
                            {
                                MessageBox.Show("   ");
                                return;
                            }
                            AddEditEmp(true);
                        }
                    }
                    break;
                case "Del":
                    if (this.tvDepts.Focused)
                        DeleteDep();
                    else
                        DeleteEmp();
                    break;
            }
        }
        /// <summary>
        /// /   
        /// </summary>
        /// <param name="mode"></param>
        private void AddEditDepts(bool mode)
        {
            if (tvDepts.SelectedNode == null && mode)
            {
                MessageBox.Show("  ");
                return;
            }
            FormDepts form = new FormDepts(connect, tvDepts, mode);
            form.ShowDialog();
        }
        /// <summary>
        ///  
        /// </summary>
        private void DeleteDep()
        {
            if (tvDepts.SelectedNode == null)
            {
                MessageBox.Show("  ");
                return;
            }
            TreeNode curnode = tvDepts.SelectedNode;
            if (curnode.Nodes.Count > 0)
            {
                MessageBox.Show("    .", " ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            else if (curnode.Parent == null)
            {
                MessageBox.Show("   .", " ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            try
            {
                string sql = "SELECT COUNT(*) FROM tblEmps WHERE nDepId =" + curnode.Tag.ToString();
                connect.Open();
                OleDbCommand comm = new OleDbCommand(sql,connect);
                if (Convert.ToInt32(comm.ExecuteScalar()) > 0)
                {
                    MessageBox.Show("   .", " ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
                if (MessageBox.Show("     " + curnode.Text + "?", " ", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.Cancel)
                    return;
                sql = "DELETE FROM tblDeps WHERE (nDepId = " + curnode.Tag.ToString() + ");";
                comm = new OleDbCommand(sql,connect);
                comm.ExecuteNonQuery();
                connect.Close();
                tvDepts.Nodes.Remove(tvDepts.SelectedNode);
            }
            catch (Exception ex)
            {
                string msg = "Error: (DeleteDep)Failed to retrieve the required data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
            }
            finally
            {
                connect.Close();
            }
        }
        /// <summary>
        ///  
        /// </summary>
        private void DeleteEmp()
        {
            if (this.lvEmps.SelectedItems.Count == 0)
            {
                MessageBox.Show("  ");
                return;
            }
            try
            {
                if (MessageBox.Show("       " + lvEmps.SelectedItems[0].Text + "?", " ", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.Cancel)
                    return;
                string sql = "DELETE FROM tblEmps WHERE (nEmpId = " + lvEmps.SelectedItems[0].Tag.ToString() + ");";
                connect.Open();
                OleDbCommand comm = new OleDbCommand(sql, connect);
                comm.ExecuteNonQuery();
                connect.Close();
                lvEmps.SelectedItems[0].Remove();
            }
            catch (Exception ex)
            {
                string msg = "Error: (DeleteEmp)Failed to retrieve the required data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
            }
            finally
            {
                connect.Close();
            }
        }
        /// <summary>
        /// /   
        /// </summary>
        /// <param name="update"></param>
        private void AddEditEmp(bool update)
        {
            FormAddEditEmp form = new FormAddEditEmp(connect,this.lvEmps, (int )this.tvDepts.SelectedNode.Tag, 
                update);
            form.ShowDialog(this);
        }
    }
}