using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Firm
{
    public partial class FormAddEditEmp : Form
    {
        private OleDbConnection _connect;
        private ListView _lvEmps;
        private bool _update = false;
        private int _nDepId = -1;
        private int _nEmpId = -1;
        DataSet _dataSet = new DataSet();
        public FormAddEditEmp(OleDbConnection aConnector, ListView aLVEmps, int anDepId, bool aUpdate)
        {
            _connect = aConnector;
            _lvEmps = aLVEmps;
            _nDepId = anDepId;
            _update = aUpdate;

            InitializeComponent();

            if (_update)
            {
                this.Text = "  ";
                _nEmpId = (int )_lvEmps.SelectedItems[0].Tag;
            }
        }

        private void FormAddEditEmp_Load(object sender, EventArgs e)
        {
            if (!_update)
                return;
            String sql = "SELECT TOP 1 * FROM tblEmps WHERE (nEmpId = " + _nEmpId.ToString() + ") ";
            try
            {

                OleDbCommand comm = new OleDbCommand(sql, _connect);
                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
                adapter.Fill(_dataSet, "tblEmps");
                _connect.Close();
                DataTable tblEmps = _dataSet.Tables["tblEmps"];
                DataRowCollection drEmps = tblEmps.Rows;
                if (drEmps.Count == 0)
                {
                    Close();
                    return;
                }
                DataRow row = drEmps[0];
                this.txtcFirstName.Text = Convert.ToString(row["cFirstName"]);
                this.txtcLastName.Text = Convert.ToString(row["cLastName"]);
                this.txtcPatronymic.Text = Convert.ToString(row["cPatronymic"]);
                this.txtcPost.Text = Convert.ToString(row["cPost"]);
                if (!row.IsNull("dBirthDate"))
                    this.dtdBirthDate.Value = Convert.ToDateTime(row["dBirthDate"]);
            }
            catch (Exception ex)
            {
                string msg = "Error: (FormAddEditEmp_Load)Failed to retrieve the required data from the DataBase.\\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                Close();
                return;
            }
            finally
            {
                _connect.Close();
            }
        }

        private void okBtn_Click(object sender, EventArgs e)
        {
            if (this.txtcLastName.TextLength == 0)
            {
                MessageBox.Show("   .", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (this.txtcFirstName.TextLength == 0)
            {
                MessageBox.Show("   .", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (this.txtcPatronymic.TextLength == 0)
            {
                MessageBox.Show("   .", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (_update)
            {
                UpdateEmp();
            }
            else
            {
                AddEmp();
            }
            DialogResult = DialogResult.OK;
            Close();
        }
        private void UpdateEmp()
        {
            string sql = "UPDATE tblEmps SET cLastName='" + this.txtcLastName.Text +
                "', cFirstName='" + this.txtcFirstName.Text + "', cPatronymic='" + this.txtcPatronymic.Text +
                "', cPost='" + this.txtcPost.Text + "' ";
            if (dtdBirthDate.Value.Year < DateTime.Now.Year)
                sql += ", dBirthDate='" + dtdBirthDate.Value + "' ";
                sql +=" WHERE (nEmpId=" + _nEmpId.ToString() + ");";
            try
            {
                OleDbCommand comm = new OleDbCommand(sql, _connect);
                //                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
                comm.ExecuteNonQuery();
                _connect.Close();
                ListViewItem it = _lvEmps.SelectedItems[0];
                //it.Text = txtcLastName.Text;
                int subit = 0;
                it.SubItems[subit++].Text = txtcLastName.Text;
                it.SubItems[subit++].Text = txtcFirstName.Text;
                it.SubItems[subit++].Text = txtcPatronymic.Text;
                it.SubItems[subit++].Text = txtcPost.Text;
                if (dtdBirthDate.Value.Year < DateTime.Now.Year)
                    it.SubItems[subit++].Text = dtdBirthDate.Value.ToShortDateString();
                else
                    it.SubItems[subit++].Text = "";
            }
            catch (Exception ex)
            {
                string msg = "Error: (UpdateEmp)Failed to retrieve the required or save data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
            }
            finally
            {
                _connect.Close();
            }
        }
        private void AddEmp()
        {
            string sql = "INSERT INTO tblEmps (nDepId,cLastName,cFirstName,cPatronymic,cPost";
            if (dtdBirthDate.Value.Year < DateTime.Now.Year)
                sql += ",dBirthDate";
            sql += ") VALUES (" + _nDepId.ToString() + ", '" +
            this.txtcLastName.Text + "', '" + this.txtcFirstName.Text + "', '" +
            this.txtcPatronymic.Text + "', '" + this.txtcPost.Text + "'";
            if (dtdBirthDate.Value.Year < DateTime.Now.Year)
                sql += ", '" + dtdBirthDate.Value + "' ";
            sql += ");";
            try
            {
                OleDbCommand comm = new OleDbCommand(sql, _connect);
                //                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
                comm.ExecuteNonQuery();
                comm = new OleDbCommand("SELECT @@IDENTITY", _connect);
                // Retrieve the identity value and store it in the CategoryID column.
                _nEmpId = (int)comm.ExecuteScalar();
                ListViewItem item = new ListViewItem(txtcLastName.Text);
                item.Tag = _nEmpId;
                item.SubItems.Add(txtcFirstName.Text);
                item.SubItems.Add(txtcPatronymic.Text);
                item.SubItems.Add(txtcPost.Text);
                if (dtdBirthDate.Value.Year < DateTime.Now.Year)
                    item.SubItems.Add(dtdBirthDate.Value.ToShortDateString());
                else
                    item.SubItems.Add("");
                _connect.Close();
                _lvEmps.Items.Add(item);
                _lvEmps.SelectedItems.Clear();
                item.Selected = true;
            }
            catch (Exception ex)
            {
                string msg = "Error: (AddEmp)Failed to save the required data to DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                //return;
            }
            finally
            {
                _connect.Close();
            }
        }
    }
}