using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Firm
{
    public partial class FormDepts : Form
    {
        private OleDbConnection _connect;
        private TreeView _tvDeps;
        private bool _update = false;
        private int nDepId = -1;
        int nPrnDepId = 0;
        public FormDepts(OleDbConnection aConnector, TreeView aTVDeps, bool aUpdate)
        {
            _tvDeps = aTVDeps;
            _connect = aConnector;
            InitializeComponent();
            _update = aUpdate;
            nDepId = (int)aTVDeps.SelectedNode.Tag;
            if (_update)
            {
                this.Text = " ";
                this.txtcCode.Text = aTVDeps.SelectedNode.Text;
                this.txtcName.Text = GetDepName();
            }
        }
        string GetDepName()
        {
            DataSet dataSet = new DataSet();
            String sql = "SELECT TOP 1 cName FROM tblDeps WHERE (nDepId = " + nDepId.ToString() + ") ";
            try
            {

                OleDbCommand comm = new OleDbCommand(sql, _connect);
                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
                adapter.Fill(dataSet, "tblDep");
            }
            catch (Exception ex)
            {
                string msg = "Error: Failed to retrieve the required data from the DataBase.\\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                return null;
            }
            finally
            {
                _connect.Close();
            }
            DataTable tblDep = dataSet.Tables["tblDep"];
            DataRowCollection drDept = tblDep.Rows;
            if (drDept.Count == 0)
                return null;
            DataRow row = drDept[0];
            return Convert.ToString(row[0]);
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            if (this.txtcName.TextLength == 0)
            {
                MessageBox.Show("    .", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (this.txtcCode.TextLength == 0)
            {
                MessageBox.Show("    .", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (_update)
            {
                UpdateDept();
            }
            else
            {
                AddDept();
            }
            DialogResult = DialogResult.OK;
            Close();
        }
        private void AddDept()
        {
            string sql = "INSERT INTO tblDeps (nPrnDepId,cCode,cName) VALUES (" + 
                nDepId.ToString() + ", '" + 
                this.txtcCode.Text + "', '" + this.txtcName.Text + "');";
			try
			{
			    OleDbCommand comm = new OleDbCommand(sql, _connect);
//                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
				comm.ExecuteNonQuery();	
                comm = new OleDbCommand("SELECT @@IDENTITY", _connect);
                // Retrieve the identity value and store it in the CategoryID column.
                  int nnDepId = (int)comm.ExecuteScalar();
                  TreeNode node = new TreeNode();
                  node.Text = this.txtcCode.Text;
                  node.Tag = nnDepId;
                  _tvDeps.SelectedNode.Nodes.Add(node);
                  _connect.Close();
                  _tvDeps.SelectedNode = node;
              }
			catch(Exception ex)
            {
                string msg = "Error: (AddDept)Failed to retrieve the required data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
                //return;
            }
            finally
            {
                _connect.Close();
            }
        }

        private void UpdateDept()
        {
            string sql = "UPDATE tblDeps SET cCode='" + this.txtcCode.Text + "', cName='" +
                this.txtcName.Text + "'" + "WHERE (nDepId=" + nDepId + ")";
            try
            {
                string cName = GetDepName();
                OleDbCommand comm = new OleDbCommand(sql, _connect);
                //                OleDbDataAdapter adapter = new OleDbDataAdapter(comm);
                _connect.Open();
                comm.ExecuteNonQuery();
                _connect.Close();
                TreeNode node = _tvDeps.SelectedNode;
                node.Text = this.txtcCode.Text;
            }
            catch (Exception ex)
            {
                string msg = "Error: (UpdateDept)Failed to retrieve the required data from the DataBase.\n";
                msg += ex.Message;
                MessageBox.Show(msg);
            }
            finally
            {
                _connect.Close();
            }
        }
    }
}